/*  www.sgm.siedlce.pl

test detekcji 1 kanalu odbiornika RC
w oparciu o przerwanie;
obsługa przerwania --> procedury:
void pulse_rising()
void pulse_falling()

pomiar czasu --> standardowa funkcja micros()

*/


//deklaracje zmiennych
volatile int pulse1_start = 0;  //zmienna dla czasu
int pulse1_micros = 0;          //zmienna na dlugosc impulsu
                                //kanalowego PPM

//inicjalizacja programu  
void setup() {
  //inicjalizacja portu szeregowego (prezentacja danych)
  Serial.begin(115200); 
  //inicjalizacja przerwania 0 (pin 2, Arduino UNO)
  attachInterrupt(0, pulse_rising, RISING);  
}

//glowna petla programu
void loop() {
  // tutaj program uzytkowy, bazujacy na zmierzonym
  // czasie trwania impulsu kanalowego PPM
  
  
  //obsulga zmiennych do drukowania pomiaru na port szeregowy 
  static unsigned long t_start = millis();
  unsigned long t_print_count = millis(); 
  
  //jesli uplynelo 500msec to drukuj
  if ((t_print_count - t_start) >= 500) 
  {
    t_start = t_print_count;
    Serial.print("pulse1 = "); Serial.println(pulse1_micros); 
  }

} // koniec glownej petli



// obsluga przerwania (rising)
void pulse_rising() {
  attachInterrupt(0, pulse_falling, FALLING);
  pulse1_start = micros();
}

// obsluga przerwania (falling) 
void pulse_falling() {
  attachInterrupt(0, pulse_rising, RISING);
  pulse1_micros = micros()-pulse1_start;
}





